• Home
  • Line#
  • Scopes#
  • Navigate#
  • Raw
  • Download
1####
2# kbuild: Generic definitions
3
4# Convenient variables
5comma   := ,
6quote   := "
7squote  := '
8empty   :=
9space   := $(empty) $(empty)
10space_escape := _-_SPACE_-_
11pound := \#
12
13###
14# Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
15dot-target = $(dir $@).$(notdir $@)
16
17###
18# The temporary file to save gcc -MD generated dependencies must not
19# contain a comma
20depfile = $(subst $(comma),_,$(dot-target).d)
21
22###
23# filename of target with directory and extension stripped
24basetarget = $(basename $(notdir $@))
25
26###
27# filename of first prerequisite with directory and extension stripped
28baseprereq = $(basename $(notdir $<))
29
30###
31# Escape single quote for use in echo statements
32escsq = $(subst $(squote),'\$(squote)',$1)
33
34###
35# Easy method for doing a status message
36       kecho := :
37 quiet_kecho := echo
38silent_kecho := :
39kecho := $($(quiet)kecho)
40
41###
42# filechk is used to check if the content of a generated file is updated.
43# Sample usage:
44# define filechk_sample
45#	echo $KERNELRELEASE
46# endef
47# version.h : Makefile
48#	$(call filechk,sample)
49# The rule defined shall write to stdout the content of the new file.
50# The existing file will be compared with the new one.
51# - If no file exist it is created
52# - If the content differ the new file is used
53# - If they are equal no change, and no timestamp update
54# - stdin is piped in from the first prerequisite ($<) so one has
55#   to specify a valid file as first prerequisite (often the kbuild file)
56define filechk
57	$(Q)set -e;				\
58	$(kecho) '  CHK     $@';		\
59	mkdir -p $(dir $@);			\
60	$(filechk_$(1)) < $< > $@.tmp;		\
61	if [ -r $@ ] && cmp -s $@ $@.tmp; then	\
62		rm -f $@.tmp;			\
63	else					\
64		$(kecho) '  UPD     $@';	\
65		mv -f $@.tmp $@;		\
66	fi
67endef
68
69######
70# gcc support functions
71# See documentation in Documentation/kbuild/makefiles.txt
72
73# cc-cross-prefix
74# Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
75# Return first prefix where a prefix$(CC) is found in PATH.
76# If no $(CC) found in PATH with listed prefixes return nothing
77cc-cross-prefix =  \
78	$(word 1, $(foreach c,$(1),                                   \
79		$(shell set -e;                                       \
80		if (which $(strip $(c))$(CC)) > /dev/null 2>&1 ; then \
81			echo $(c);                                    \
82		fi)))
83
84# output directory for tests below
85TMPOUT := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/)
86
87# try-run
88# Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
89# Exit code chooses option. "$$TMP" serves as a temporary file and is
90# automatically cleaned up.
91try-run = $(shell set -e;		\
92	TMP="$(TMPOUT).$$$$.tmp";	\
93	TMPO="$(TMPOUT).$$$$.o";	\
94	if ($(1)) >/dev/null 2>&1;	\
95	then echo "$(2)";		\
96	else echo "$(3)";		\
97	fi;				\
98	rm -f "$$TMP" "$$TMPO")
99
100# as-option
101# Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
102
103as-option = $(call try-run,\
104	$(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
105
106# as-instr
107# Usage: cflags-y += $(call as-instr,instr,option1,option2)
108
109as-instr = $(call try-run,\
110	printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
111
112# __cc-option
113# Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
114__cc-option = $(call try-run,\
115	$(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
116
117# Do not attempt to build with gcc plugins during cc-option tests.
118# (And this uses delayed resolution so the flags will be up to date.)
119CC_OPTION_CFLAGS = $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
120
121# cc-option
122# Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
123
124cc-option = $(call __cc-option, $(CC),\
125	$(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS),$(1),$(2))
126
127# hostcc-option
128# Usage: cflags-y += $(call hostcc-option,-march=winchip-c6,-march=i586)
129hostcc-option = $(call __cc-option, $(HOSTCC),\
130	$(HOSTCFLAGS) $(HOST_EXTRACFLAGS),$(1),$(2))
131
132# cc-option-yn
133# Usage: flag := $(call cc-option-yn,-march=winchip-c6)
134cc-option-yn = $(call try-run,\
135	$(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
136
137# cc-disable-warning
138# Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
139cc-disable-warning = $(call try-run,\
140	$(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
141
142# cc-name
143# Expands to either gcc or clang
144cc-name = $(shell $(CC) -v 2>&1 | grep -q "clang version" && echo clang || echo gcc)
145
146# __cc-version
147# Returns compiler version
148__cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/$(cc-name)-version.sh $(CC))
149
150# __cc-fullversion
151# Returns full compiler version
152__cc-fullversion = $(shell $(CONFIG_SHELL) \
153	$(srctree)/scripts/$(cc-name)-version.sh -p $(CC))
154
155# __cc-ifversion
156# Matches compiler name and version
157# Usage:  EXTRA_CFLAGS += $(call cc-if-name-version, gcc, -lt, 0402, -O1)
158__cc-ifversion = $(shell [ $(cc-name) = $(1) ] && [ $(__cc-version) $(2) $(3) ] && echo $(4) || echo $(5))
159
160# __cc-if-fullversion
161# Matches compiler name and full version
162# Usage:  EXTRA_CFLAGS += $(call cc-if-name-fullversion, gcc, -lt, 040502, -O1)
163__cc-if-fullversion = $(shell [ $(cc-name) = $(1) ] && [ $(__cc-fullversion) $(2) $(3) ] && echo $(4) || echo $(5))
164
165# gcc-ifversion
166gcc-ifversion = $(call __cc-ifversion, gcc, $(1), $(2), $(3), $(4))
167
168# gcc-if-fullversion
169gcc-if-fullversion = (call __cc-if-fullversion, gcc, $(1), $(2), $(3), $(4))
170
171# clang-ifversion
172clang-ifversion =  $(call __cc-ifversion, clang, $(1), $(2), $(3), $(4))
173
174# clang-if-fullversion
175clang-if-fullversion = (call __cc-if-fullversion, clang, $(1), $(2), $(3), $(4))
176
177# cc-version
178cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh $(CC))
179
180# cc-fullversion
181cc-fullversion = $(shell $(CONFIG_SHELL) \
182	$(srctree)/scripts/gcc-version.sh -p $(CC))
183
184# backward compatibility
185cc-ifversion = $(gcc-ifversion)
186cc-if-fullversion = $(gcc-if-fullversion)
187
188# cc-if-fullversion
189# Usage:  EXTRA_CFLAGS += $(call cc-if-fullversion, -lt, 040502, -O1)
190cc-if-fullversion = $(shell [ $(cc-fullversion) $(1) $(2) ] && echo $(3) || echo $(4))
191
192# cc-ldoption
193# Usage: ldflags += $(call cc-ldoption, -Wl$(comma)--hash-style=both)
194cc-ldoption = $(call try-run,\
195	$(CC) $(1) $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -nostdlib -x c /dev/null -o "$$TMP",$(1),$(2))
196
197# ld-option
198# Usage: LDFLAGS += $(call ld-option, -X)
199ld-option = $(call try-run, $(LD) $(LDFLAGS) $(1) -v,$(1),$(2))
200
201# ar-option
202# Usage: KBUILD_ARFLAGS := $(call ar-option,D)
203# Important: no spaces around options
204ar-option = $(call try-run, $(AR) rc$(1) "$$TMP",$(1),$(2))
205
206# ld-name
207# Expands to either bfd or gold
208ld-name = $(shell $(LD) -v 2>&1 | grep -q "GNU gold" && echo gold || echo bfd)
209
210# ld-version
211# Note this is mainly for HJ Lu's 3 number binutil versions
212ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
213
214# ld-ifversion
215# Usage:  $(call ld-ifversion, -ge, 22252, y)
216ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
217
218# __ld-ifversion
219# Usage:  $(call __ld-ifversion, gold, -ge, 112000000, y)
220__ld-ifversion = $(shell [ $(ld-name) = $(1) ] && [ $(ld-version) $(2) $(3) ] && echo $(4) || echo $(5))
221
222# bfd-ifversion
223# Usage:  $(call bfd-ifversion, -ge, 227000000, y)
224bfd-ifversion = $(call __ld-ifversion, bfd, $(1), $(2), $(3), $(4))
225
226# gold-ifversion
227# Usage:  $(call gold-ifversion, -ge, 112000000, y)
228gold-ifversion = $(call __ld-ifversion, gold, $(1), $(2), $(3), $(4))
229
230######
231
232###
233# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
234# Usage:
235# $(Q)$(MAKE) $(build)=dir
236build := -f $(srctree)/scripts/Makefile.build obj
237
238###
239# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.modbuiltin obj=
240# Usage:
241# $(Q)$(MAKE) $(modbuiltin)=dir
242modbuiltin := -f $(srctree)/scripts/Makefile.modbuiltin obj
243
244###
245# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
246# Usage:
247# $(Q)$(MAKE) $(dtbinst)=dir
248dtbinst := -f $(if $(KBUILD_SRC),$(srctree)/)scripts/Makefile.dtbinst obj
249
250###
251# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
252# Usage:
253# $(Q)$(MAKE) $(clean)=dir
254clean := -f $(srctree)/scripts/Makefile.clean obj
255
256###
257# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.headersinst obj=
258# Usage:
259# $(Q)$(MAKE) $(hdr-inst)=dir
260hdr-inst := -f $(srctree)/scripts/Makefile.headersinst obj
261
262# Prefix -I with $(srctree) if it is not an absolute path.
263# skip if -I has no parameter
264addtree = $(if $(patsubst -I%,%,$(1)), \
265$(if $(filter-out -I/% -I./% -I../%,$(1)),$(patsubst -I%,-I$(srctree)/%,$(1)),$(1)))
266
267# Find all -I options and call addtree
268flags = $(foreach o,$($(1)),$(if $(filter -I%,$(o)),$(call addtree,$(o)),$(o)))
269
270# echo command.
271# Short version is used, if $(quiet) equals `quiet_', otherwise full one.
272echo-cmd = $(if $($(quiet)cmd_$(1)),\
273	echo '  $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
274
275# printing commands
276cmd = @$(echo-cmd) $(cmd_$(1))
277
278# Add $(obj)/ for paths that are not absolute
279objectify = $(foreach o,$(1),$(if $(filter /%,$(o)),$(o),$(obj)/$(o)))
280
281###
282# if_changed      - execute command if any prerequisite is newer than
283#                   target, or command line has changed
284# if_changed_dep  - as if_changed, but uses fixdep to reveal dependencies
285#                   including used config symbols
286# if_changed_rule - as if_changed but execute rule instead
287# See Documentation/kbuild/makefiles.txt for more info
288
289ifneq ($(KBUILD_NOCMDDEP),1)
290# Check if both arguments are the same including their order. Result is empty
291# string if equal. User may override this check using make KBUILD_NOCMDDEP=1
292arg-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
293                         $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
294else
295arg-check = $(if $(strip $(cmd_$@)),,1)
296endif
297
298# Replace >$< with >$$< to preserve $ when reloading the .cmd file
299# (needed for make)
300# Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
301# (needed for make)
302# Replace >'< with >'\''< to be able to enclose the whole string in '...'
303# (needed for the shell)
304make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
305
306# Find any prerequisites that is newer than target or that does not exist.
307# PHONY targets skipped in both cases.
308any-prereq = $(filter-out $(PHONY),$?) $(filter-out $(PHONY) $(wildcard $^),$^)
309
310# Execute command if command has changed or prerequisite(s) are updated.
311if_changed = $(if $(strip $(any-prereq) $(arg-check)),                       \
312	@set -e;                                                             \
313	$(echo-cmd) $(cmd_$(1));                                             \
314	printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
315
316# Execute the command and also postprocess generated .d dependencies file.
317if_changed_dep = $(if $(strip $(any-prereq) $(arg-check) ),                  \
318	@set -e;                                                             \
319	$(cmd_and_fixdep), @:)
320
321ifndef CONFIG_TRIM_UNUSED_KSYMS
322
323cmd_and_fixdep =                                                             \
324	$(echo-cmd) $(cmd_$(1));                                             \
325	scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).tmp;\
326	rm -f $(depfile);                                                    \
327	mv -f $(dot-target).tmp $(dot-target).cmd;
328
329else
330
331# Filter out exported kernel symbol names from the preprocessor output.
332# See also __KSYM_DEPS__ in include/linux/export.h.
333# We disable the depfile generation here, so as not to overwrite the existing
334# depfile while fixdep is parsing it.
335flags_nodeps = $(filter-out -Wp$(comma)-M%, $($(1)))
336ksym_dep_filter =                                                            \
337	case "$(1)" in                                                       \
338	  cc_*_c|cpp_i_c)                                                    \
339	    $(CPP) $(call flags_nodeps,c_flags) -D__KSYM_DEPS__ $< ;;        \
340	  as_*_S|cpp_s_S)                                                    \
341	    $(CPP) $(call flags_nodeps,a_flags) -D__KSYM_DEPS__ $< ;;        \
342	  boot*|build*|cpp_its_S|*cpp_lds_S|dtc|host*|vdso*) : ;;            \
343	  *) echo "Don't know how to preprocess $(1)" >&2; false ;;          \
344	esac | tr ";" "\n" | sed -rn 's/^.*=== __KSYM_(.*) ===.*$$/KSYM_\1/p'
345
346cmd_and_fixdep =                                                             \
347	$(echo-cmd) $(cmd_$(1));                                             \
348	$(ksym_dep_filter) |                                                 \
349		scripts/basic/fixdep -e $(depfile) $@ '$(make-cmd)'          \
350			> $(dot-target).tmp;	                             \
351	rm -f $(depfile);                                                    \
352	mv -f $(dot-target).tmp $(dot-target).cmd;
353
354endif
355
356# Usage: $(call if_changed_rule,foo)
357# Will check if $(cmd_foo) or any of the prerequisites changed,
358# and if so will execute $(rule_foo).
359if_changed_rule = $(if $(strip $(any-prereq) $(arg-check) ),                 \
360	@set -e;                                                             \
361	$(rule_$(1)), @:)
362
363###
364# why - tell why a target got built
365#       enabled by make V=2
366#       Output (listed in the order they are checked):
367#          (1) - due to target is PHONY
368#          (2) - due to target missing
369#          (3) - due to: file1.h file2.h
370#          (4) - due to command line change
371#          (5) - due to missing .cmd file
372#          (6) - due to target not in $(targets)
373# (1) PHONY targets are always build
374# (2) No target, so we better build it
375# (3) Prerequisite is newer than target
376# (4) The command line stored in the file named dir/.target.cmd
377#     differed from actual command line. This happens when compiler
378#     options changes
379# (5) No dir/.target.cmd file (used to store command line)
380# (6) No dir/.target.cmd file and target not listed in $(targets)
381#     This is a good hint that there is a bug in the kbuild file
382ifeq ($(KBUILD_VERBOSE),2)
383why =                                                                        \
384    $(if $(filter $@, $(PHONY)),- due to target is PHONY,                    \
385        $(if $(wildcard $@),                                                 \
386            $(if $(strip $(any-prereq)),- due to: $(any-prereq),             \
387                $(if $(arg-check),                                           \
388                    $(if $(cmd_$@),- due to command line change,             \
389                        $(if $(filter $@, $(targets)),                       \
390                            - due to missing .cmd file,                      \
391                            - due to $(notdir $@) not in $$(targets)         \
392                         )                                                   \
393                     )                                                       \
394                 )                                                           \
395             ),                                                              \
396             - due to target missing                                         \
397         )                                                                   \
398     )
399
400echo-why = $(call escsq, $(strip $(why)))
401endif
402
403###############################################################################
404#
405# When a Kconfig string contains a filename, it is suitable for
406# passing to shell commands. It is surrounded by double-quotes, and
407# any double-quotes or backslashes within it are escaped by
408# backslashes.
409#
410# This is no use for dependencies or $(wildcard). We need to strip the
411# surrounding quotes and the escaping from quotes and backslashes, and
412# we *do* need to escape any spaces in the string. So, for example:
413#
414# Usage: $(eval $(call config_filename,FOO))
415#
416# Defines FOO_FILENAME based on the contents of the CONFIG_FOO option,
417# transformed as described above to be suitable for use within the
418# makefile.
419#
420# Also, if the filename is a relative filename and exists in the source
421# tree but not the build tree, define FOO_SRCPREFIX as $(srctree)/ to
422# be prefixed to *both* command invocation and dependencies.
423#
424# Note: We also print the filenames in the quiet_cmd_foo text, and
425# perhaps ought to have a version specially escaped for that purpose.
426# But it's only cosmetic, and $(patsubst "%",%,$(CONFIG_FOO)) is good
427# enough.  It'll strip the quotes in the common case where there's no
428# space and it's a simple filename, and it'll retain the quotes when
429# there's a space. There are some esoteric cases in which it'll print
430# the wrong thing, but we don't really care. The actual dependencies
431# and commands *do* get it right, with various combinations of single
432# and double quotes, backslashes and spaces in the filenames.
433#
434###############################################################################
435#
436define config_filename
437ifneq ($$(CONFIG_$(1)),"")
438$(1)_FILENAME := $$(subst \\,\,$$(subst \$$(quote),$$(quote),$$(subst $$(space_escape),\$$(space),$$(patsubst "%",%,$$(subst $$(space),$$(space_escape),$$(CONFIG_$(1)))))))
439ifneq ($$(patsubst /%,%,$$(firstword $$($(1)_FILENAME))),$$(firstword $$($(1)_FILENAME)))
440else
441ifeq ($$(wildcard $$($(1)_FILENAME)),)
442ifneq ($$(wildcard $$(srctree)/$$($(1)_FILENAME)),)
443$(1)_SRCPREFIX := $(srctree)/
444endif
445endif
446endif
447endif
448endef
449#
450###############################################################################
451
452# delete partially updated (i.e. corrupted) files on error
453.DELETE_ON_ERROR:
454